#include "hd44780.h"

// =========================================================
// L C D   R O U T I N E S
// =========================================================

void LCD_initialise()
{
   LCD_E = 0;
   LCD_RW = 0;
   LCD_RS = 0;
   LCD_delay();
   LCD_command(0x38);  //8bit, 2 lines, default font
   LCD_delay();
   LCD_command(0x08);  //turn display off
   LCD_delay();
   LCD_command(0x0C);  //turn display on, no cursor
   LCD_delay();
   LCD_cleardisplay();
   LCD_delay();
}

void LCD_turnoncursor()
{
   LCD_command(0x0F);
}

void LCD_turnoffcursor()
{
   LCD_command(0x0C);
}

void LCD_cleardisplay()
{
   LCD_command(0x01);
}

void LCD_newline()
{
   LCD_command(0xC0);
}

void LCD_placecursor(unsigned char place)
{
   LCD_command(0x80 + place);
}

void LCD_download_custom_char(unsigned int CGRAMaddress, unsigned char character[])
{
   LCD_command(0x40 + (8 * CGRAMaddress));
   for (l = 0; l<8; l++)
   {
      send_LCD_character(character[l]);
   }
      
}

void LCD_command(unsigned char command)
{
   LCD_RS = 0; //command mode
   P3 = command;
   LCD_E = 1;
   LCD_delay();
   LCD_E = 0;
   LCD_delay();
   LCD_RS = 1; //back to data mode
}

void LCD_display_string(unsigned char displaystring[]) 
{
   l = 0;
   while (displaystring[l] != 0x00) 
   {
      send_LCD_character(displaystring[l]);
	  l++;
   }
   l = 0;
}

void send_LCD_character(unsigned char character) 
{
   LCD_RW = 0;
   LCD_E = 0;
   LCD_RS = 1; //data mode
   P3 = character;    //change so that can allocate whatever port you like for data
   LCD_E = 1;
   LCD_delay();
   LCD_E = 0;
   LCD_delay(); 
}
   
void LCD_delay()
{
	j = 0;
	while (j !=2000) 
	{  //let the LCD settle
	    j++;
	}
}

// =========================================================
// END OF L C D   R O U T I N E S
// =========================================================